local plr, popFrame, textFrame, textHeight, pat

local frame = CreateFrame("Frame")

frame:RegisterEvent("DUEL_REQUESTED")

frame:SetScript("OnEvent", function(self, event, ...)
	if event == "DUEL_REQUESTED" then
		popFrame, textFrame, textHeight = nil, nil, nil
		
		for i = 1, STATICPOPUP_NUMDIALOGS do
			popFrame = _G["StaticPopup" ..i];
			
			if popFrame:IsShown() then
				textFrame = _G["StaticPopup" ..i.. "Text"]
				textHeight = textFrame:GetHeight()
				pat = strsub(DUEL_REQUESTED, 4)
				
				local str = _G["StaticPopup" ..i.. "Text"]:GetText()
				
				if strfind(str, pat) then
					local loc = select(1, strfind(str, pat)) - 2
					plr = strsub(str, 1, loc)
					
					frame:RegisterEvent("WHO_LIST_UPDATE")
					FriendsFrame:UnregisterEvent("WHO_LIST_UPDATE")
					
					SetWhoToUI(1)
					SendWho(tostring(plr))
					
					break
				end
			end
		end
	elseif event == "WHO_LIST_UPDATE" then
		local wFound = nil
		local class, classStr = nil, nil
		
		FriendsFrame:RegisterEvent("WHO_LIST_UPDATE")
		frame:UnregisterEvent("WHO_LIST_UPDATE")
		
		local numWhos, totalCount = GetNumWhoResults()
		for w = 1, numWhos do
			local wname, wguild, wlevel, wrace, wclass, wzone, wclassFileName = GetWhoInfo(w)
			if wname == plr then
				class = wclass
				classStr = wclassFileName
				
				wFound = true
			end
		end
		
		if wFound then
			local color = "ffff00ff"
			if classStr then
				if RAID_CLASS_COLORS[classStr] then
					color = RAID_CLASS_COLORS[classStr].colorStr
				end
			end
			
			textFrame:SetText(format("%s (\124c%s%s\124r) %s", tostring(plr), tostring(color), tostring(class), pat))
			popFrame:SetHeight(popFrame:GetHeight() - textHeight + textFrame:GetHeight())
		end
	end
end);